> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/development-guide/react-native/react-native-optout.md).

# Opt-out

When opt-out is enabled, the SDK stops sending all events.

{% hint style="info" %}
The React Native SDK operates based on the Android SDK and iOS SDK.
{% endhint %}

## Configuration at Initialization

```javascript
import { createInstance, HackleProvider } from "@hackler/react-native-sdk";

const config = {
    optOutTracking: true
};

const hackleClient = createInstance("YOUR_APP_SDK_KEY", config);

const App = () => {
  return (
    <HackleProvider hackleClient={hackleClient}>
      <YourApp />
    </HackleProvider>
  );
};
```

## Runtime Opt-out Control

```javascript
hackleClient.setOptOutTracking(true);
hackleClient.setOptOutTracking(false);
const isOptOut = await hackleClient.isOptOutTracking();
```

## Persistence Management

{% hint style="warning" %}
The opt-out state changed at runtime is reset to the value configured in the initialization Config when the app restarts.

To persist the state after an app restart, you must implement your own save and restore logic.
{% endhint %}

```javascript
import AsyncStorage from '@react-native-async-storage/async-storage';

async function saveOptOutState(optOut) {
    await AsyncStorage.setItem("hackle_opt_out", JSON.stringify(optOut));
    hackleClient.setOptOutTracking(optOut);
}

async function getOptOutConfig() {
    const value = await AsyncStorage.getItem("hackle_opt_out");
    const optOut = value ? JSON.parse(value) : false;
    return {
        optOutTracking: optOut
    };
}

const config = await getOptOutConfig();
const hackleClient = createInstance("YOUR_APP_SDK_KEY", config);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hackle.io/en/development-guide/react-native/react-native-optout.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
